// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v3.21.5
// source: protos/user.proto

package user

import (
	context "context"
	common "example.com/tung-pt/go-lang/common"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// UserClient is the client API for User service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type UserClient interface {
	// Create or Update User
	UserSynchronizedInformation(ctx context.Context, in *UserRequest, opts ...grpc.CallOption) (*common.MessageResponse, error)
	UserUpdatePinCode(ctx context.Context, in *UserPinFromMessage, opts ...grpc.CallOption) (*common.MessageResponse, error)
	UserUpdateDeviceIdentifier(ctx context.Context, in *DeviceAddRequestFrom3RdMessage, opts ...grpc.CallOption) (*common.MessageResponse, error)
	UserAddDeviceFirebasetoken(ctx context.Context, in *AddFirebaseRequestMessage3Rd, opts ...grpc.CallOption) (*common.MessageResponse, error)
	UserGetCertificates(ctx context.Context, in *RequestListCertificate, opts ...grpc.CallOption) (*ListCertificateResponseDetailMessage, error)
	UserGetCertificateDetail(ctx context.Context, in *GetCertificateDetailOfUserMessage, opts ...grpc.CallOption) (*GetCertificateDetailOfUserResponseDetailMessage, error)
	UserCreateEformRequestCertificate(ctx context.Context, in *CreateEFormRequestCertFrom3RdMessage, opts ...grpc.CallOption) (*CreateEFormRequestCertFrom3RdResponseDataMessage, error)
	UserConfirmEformRequestCertificate(ctx context.Context, in *ConfirmEFormRequestCertFrom3RdMessage, opts ...grpc.CallOption) (*ConfirmEFormRequestCertFrom3RdResponseDataMessage, error)
	UserCreateEformUseDigital(ctx context.Context, in *CreateEFormFrom3RdMessage, opts ...grpc.CallOption) (*CreateEFormFrom3RdResponseDataMessage, error)
	UserConfirmEformUseDigital(ctx context.Context, in *ConfirmEFormFrom3RdMessage, opts ...grpc.CallOption) (*ConfirmEFormFrom3RdResponseDataMessage, error)
}

type userClient struct {
	cc grpc.ClientConnInterface
}

func NewUserClient(cc grpc.ClientConnInterface) UserClient {
	return &userClient{cc}
}

func (c *userClient) UserSynchronizedInformation(ctx context.Context, in *UserRequest, opts ...grpc.CallOption) (*common.MessageResponse, error) {
	out := new(common.MessageResponse)
	err := c.cc.Invoke(ctx, "/user.User/UserSynchronizedInformation", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *userClient) UserUpdatePinCode(ctx context.Context, in *UserPinFromMessage, opts ...grpc.CallOption) (*common.MessageResponse, error) {
	out := new(common.MessageResponse)
	err := c.cc.Invoke(ctx, "/user.User/UserUpdatePinCode", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *userClient) UserUpdateDeviceIdentifier(ctx context.Context, in *DeviceAddRequestFrom3RdMessage, opts ...grpc.CallOption) (*common.MessageResponse, error) {
	out := new(common.MessageResponse)
	err := c.cc.Invoke(ctx, "/user.User/UserUpdateDeviceIdentifier", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *userClient) UserAddDeviceFirebasetoken(ctx context.Context, in *AddFirebaseRequestMessage3Rd, opts ...grpc.CallOption) (*common.MessageResponse, error) {
	out := new(common.MessageResponse)
	err := c.cc.Invoke(ctx, "/user.User/UserAddDeviceFirebasetoken", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *userClient) UserGetCertificates(ctx context.Context, in *RequestListCertificate, opts ...grpc.CallOption) (*ListCertificateResponseDetailMessage, error) {
	out := new(ListCertificateResponseDetailMessage)
	err := c.cc.Invoke(ctx, "/user.User/UserGetCertificates", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *userClient) UserGetCertificateDetail(ctx context.Context, in *GetCertificateDetailOfUserMessage, opts ...grpc.CallOption) (*GetCertificateDetailOfUserResponseDetailMessage, error) {
	out := new(GetCertificateDetailOfUserResponseDetailMessage)
	err := c.cc.Invoke(ctx, "/user.User/UserGetCertificateDetail", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *userClient) UserCreateEformRequestCertificate(ctx context.Context, in *CreateEFormRequestCertFrom3RdMessage, opts ...grpc.CallOption) (*CreateEFormRequestCertFrom3RdResponseDataMessage, error) {
	out := new(CreateEFormRequestCertFrom3RdResponseDataMessage)
	err := c.cc.Invoke(ctx, "/user.User/UserCreateEformRequestCertificate", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *userClient) UserConfirmEformRequestCertificate(ctx context.Context, in *ConfirmEFormRequestCertFrom3RdMessage, opts ...grpc.CallOption) (*ConfirmEFormRequestCertFrom3RdResponseDataMessage, error) {
	out := new(ConfirmEFormRequestCertFrom3RdResponseDataMessage)
	err := c.cc.Invoke(ctx, "/user.User/UserConfirmEformRequestCertificate", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *userClient) UserCreateEformUseDigital(ctx context.Context, in *CreateEFormFrom3RdMessage, opts ...grpc.CallOption) (*CreateEFormFrom3RdResponseDataMessage, error) {
	out := new(CreateEFormFrom3RdResponseDataMessage)
	err := c.cc.Invoke(ctx, "/user.User/UserCreateEformUseDigital", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *userClient) UserConfirmEformUseDigital(ctx context.Context, in *ConfirmEFormFrom3RdMessage, opts ...grpc.CallOption) (*ConfirmEFormFrom3RdResponseDataMessage, error) {
	out := new(ConfirmEFormFrom3RdResponseDataMessage)
	err := c.cc.Invoke(ctx, "/user.User/UserConfirmEformUseDigital", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// UserServer is the server API for User service.
// All implementations must embed UnimplementedUserServer
// for forward compatibility
type UserServer interface {
	// Create or Update User
	UserSynchronizedInformation(context.Context, *UserRequest) (*common.MessageResponse, error)
	UserUpdatePinCode(context.Context, *UserPinFromMessage) (*common.MessageResponse, error)
	UserUpdateDeviceIdentifier(context.Context, *DeviceAddRequestFrom3RdMessage) (*common.MessageResponse, error)
	UserAddDeviceFirebasetoken(context.Context, *AddFirebaseRequestMessage3Rd) (*common.MessageResponse, error)
	UserGetCertificates(context.Context, *RequestListCertificate) (*ListCertificateResponseDetailMessage, error)
	UserGetCertificateDetail(context.Context, *GetCertificateDetailOfUserMessage) (*GetCertificateDetailOfUserResponseDetailMessage, error)
	UserCreateEformRequestCertificate(context.Context, *CreateEFormRequestCertFrom3RdMessage) (*CreateEFormRequestCertFrom3RdResponseDataMessage, error)
	UserConfirmEformRequestCertificate(context.Context, *ConfirmEFormRequestCertFrom3RdMessage) (*ConfirmEFormRequestCertFrom3RdResponseDataMessage, error)
	UserCreateEformUseDigital(context.Context, *CreateEFormFrom3RdMessage) (*CreateEFormFrom3RdResponseDataMessage, error)
	UserConfirmEformUseDigital(context.Context, *ConfirmEFormFrom3RdMessage) (*ConfirmEFormFrom3RdResponseDataMessage, error)
	mustEmbedUnimplementedUserServer()
}

// UnimplementedUserServer must be embedded to have forward compatible implementations.
type UnimplementedUserServer struct {
}

func (UnimplementedUserServer) UserSynchronizedInformation(context.Context, *UserRequest) (*common.MessageResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UserSynchronizedInformation not implemented")
}
func (UnimplementedUserServer) UserUpdatePinCode(context.Context, *UserPinFromMessage) (*common.MessageResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UserUpdatePinCode not implemented")
}
func (UnimplementedUserServer) UserUpdateDeviceIdentifier(context.Context, *DeviceAddRequestFrom3RdMessage) (*common.MessageResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UserUpdateDeviceIdentifier not implemented")
}
func (UnimplementedUserServer) UserAddDeviceFirebasetoken(context.Context, *AddFirebaseRequestMessage3Rd) (*common.MessageResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UserAddDeviceFirebasetoken not implemented")
}
func (UnimplementedUserServer) UserGetCertificates(context.Context, *RequestListCertificate) (*ListCertificateResponseDetailMessage, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UserGetCertificates not implemented")
}
func (UnimplementedUserServer) UserGetCertificateDetail(context.Context, *GetCertificateDetailOfUserMessage) (*GetCertificateDetailOfUserResponseDetailMessage, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UserGetCertificateDetail not implemented")
}
func (UnimplementedUserServer) UserCreateEformRequestCertificate(context.Context, *CreateEFormRequestCertFrom3RdMessage) (*CreateEFormRequestCertFrom3RdResponseDataMessage, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UserCreateEformRequestCertificate not implemented")
}
func (UnimplementedUserServer) UserConfirmEformRequestCertificate(context.Context, *ConfirmEFormRequestCertFrom3RdMessage) (*ConfirmEFormRequestCertFrom3RdResponseDataMessage, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UserConfirmEformRequestCertificate not implemented")
}
func (UnimplementedUserServer) UserCreateEformUseDigital(context.Context, *CreateEFormFrom3RdMessage) (*CreateEFormFrom3RdResponseDataMessage, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UserCreateEformUseDigital not implemented")
}
func (UnimplementedUserServer) UserConfirmEformUseDigital(context.Context, *ConfirmEFormFrom3RdMessage) (*ConfirmEFormFrom3RdResponseDataMessage, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UserConfirmEformUseDigital not implemented")
}
func (UnimplementedUserServer) mustEmbedUnimplementedUserServer() {}

// UnsafeUserServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to UserServer will
// result in compilation errors.
type UnsafeUserServer interface {
	mustEmbedUnimplementedUserServer()
}

func RegisterUserServer(s grpc.ServiceRegistrar, srv UserServer) {
	s.RegisterService(&User_ServiceDesc, srv)
}

func _User_UserSynchronizedInformation_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UserRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UserServer).UserSynchronizedInformation(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/user.User/UserSynchronizedInformation",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UserServer).UserSynchronizedInformation(ctx, req.(*UserRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _User_UserUpdatePinCode_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UserPinFromMessage)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UserServer).UserUpdatePinCode(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/user.User/UserUpdatePinCode",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UserServer).UserUpdatePinCode(ctx, req.(*UserPinFromMessage))
	}
	return interceptor(ctx, in, info, handler)
}

func _User_UserUpdateDeviceIdentifier_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DeviceAddRequestFrom3RdMessage)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UserServer).UserUpdateDeviceIdentifier(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/user.User/UserUpdateDeviceIdentifier",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UserServer).UserUpdateDeviceIdentifier(ctx, req.(*DeviceAddRequestFrom3RdMessage))
	}
	return interceptor(ctx, in, info, handler)
}

func _User_UserAddDeviceFirebasetoken_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(AddFirebaseRequestMessage3Rd)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UserServer).UserAddDeviceFirebasetoken(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/user.User/UserAddDeviceFirebasetoken",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UserServer).UserAddDeviceFirebasetoken(ctx, req.(*AddFirebaseRequestMessage3Rd))
	}
	return interceptor(ctx, in, info, handler)
}

func _User_UserGetCertificates_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(RequestListCertificate)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UserServer).UserGetCertificates(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/user.User/UserGetCertificates",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UserServer).UserGetCertificates(ctx, req.(*RequestListCertificate))
	}
	return interceptor(ctx, in, info, handler)
}

func _User_UserGetCertificateDetail_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetCertificateDetailOfUserMessage)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UserServer).UserGetCertificateDetail(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/user.User/UserGetCertificateDetail",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UserServer).UserGetCertificateDetail(ctx, req.(*GetCertificateDetailOfUserMessage))
	}
	return interceptor(ctx, in, info, handler)
}

func _User_UserCreateEformRequestCertificate_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateEFormRequestCertFrom3RdMessage)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UserServer).UserCreateEformRequestCertificate(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/user.User/UserCreateEformRequestCertificate",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UserServer).UserCreateEformRequestCertificate(ctx, req.(*CreateEFormRequestCertFrom3RdMessage))
	}
	return interceptor(ctx, in, info, handler)
}

func _User_UserConfirmEformRequestCertificate_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ConfirmEFormRequestCertFrom3RdMessage)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UserServer).UserConfirmEformRequestCertificate(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/user.User/UserConfirmEformRequestCertificate",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UserServer).UserConfirmEformRequestCertificate(ctx, req.(*ConfirmEFormRequestCertFrom3RdMessage))
	}
	return interceptor(ctx, in, info, handler)
}

func _User_UserCreateEformUseDigital_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateEFormFrom3RdMessage)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UserServer).UserCreateEformUseDigital(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/user.User/UserCreateEformUseDigital",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UserServer).UserCreateEformUseDigital(ctx, req.(*CreateEFormFrom3RdMessage))
	}
	return interceptor(ctx, in, info, handler)
}

func _User_UserConfirmEformUseDigital_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ConfirmEFormFrom3RdMessage)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UserServer).UserConfirmEformUseDigital(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/user.User/UserConfirmEformUseDigital",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UserServer).UserConfirmEformUseDigital(ctx, req.(*ConfirmEFormFrom3RdMessage))
	}
	return interceptor(ctx, in, info, handler)
}

// User_ServiceDesc is the grpc.ServiceDesc for User service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var User_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "user.User",
	HandlerType: (*UserServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "UserSynchronizedInformation",
			Handler:    _User_UserSynchronizedInformation_Handler,
		},
		{
			MethodName: "UserUpdatePinCode",
			Handler:    _User_UserUpdatePinCode_Handler,
		},
		{
			MethodName: "UserUpdateDeviceIdentifier",
			Handler:    _User_UserUpdateDeviceIdentifier_Handler,
		},
		{
			MethodName: "UserAddDeviceFirebasetoken",
			Handler:    _User_UserAddDeviceFirebasetoken_Handler,
		},
		{
			MethodName: "UserGetCertificates",
			Handler:    _User_UserGetCertificates_Handler,
		},
		{
			MethodName: "UserGetCertificateDetail",
			Handler:    _User_UserGetCertificateDetail_Handler,
		},
		{
			MethodName: "UserCreateEformRequestCertificate",
			Handler:    _User_UserCreateEformRequestCertificate_Handler,
		},
		{
			MethodName: "UserConfirmEformRequestCertificate",
			Handler:    _User_UserConfirmEformRequestCertificate_Handler,
		},
		{
			MethodName: "UserCreateEformUseDigital",
			Handler:    _User_UserCreateEformUseDigital_Handler,
		},
		{
			MethodName: "UserConfirmEformUseDigital",
			Handler:    _User_UserConfirmEformUseDigital_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "protos/user.proto",
}
